/*  Call a command for every file (not directory)  */
/*  Usage: foreach [-rlv] <filespec> <command>     */
/*         -r : search subdirectories              */
/*         -l : list found files                   */
/*         -v : type command before executing      */
/*  {} in command will be replaced with filename   */
/*  Use @ as empty command                         */

if (arg( ) = "0") then do
  say "Usage: foreach [-rlv] <filespec> <command>"
  exit
end

cmdline = arg(1)
treeflag = "FO"
list = "0"
verbose = "0"
if left(cmdline, 1) = '-' then do
  k = pos(' ', cmdline)
  flags = left(cmdline, k-1)
  cmdline = substr(cmdline, k+1)
  if pos('r', flags) > 0 then treeflag = "SFO"
  list = pos('l', flags)
  verbose = pos('v', flags)
end

do while left(cmdline,1) = ' '
  cmdline = substr(cmdline, 2)
end

k = pos(' ', cmdline)
if k = 0 then do
  say "Usage: foreach [-rlv] <filespec> <command>"
  exit
end
mask = left(cmdline, k)
cmdline = substr(cmdline, k+1)

call RxFuncAdd 'SysFileTree', 'RexxUtil', 'SysFileTree'

rc = SysFileTree(mask, filelist, treeflag)

if rc > '0' then do
  say "Error: not enough memory."
  exit
end

if filelist.0 = '0' then do
  say "No files matching "mask
  exit
end

if list > '0' then do
  say filelist.0" files found:"
  do i = 1 to filelist.0
    say filelist.i
  end
end

do i = 1 to filelist.0
  commandline = cmdline
  k = pos('{}', commandline);
  do while k > '0'
    commandline = left(commandline, k-1)''filelist.i''substr(commandline, k+2)
    k = pos('{}', commandline);
  end;
  if verbose > '0' then say commandline
  '@'commandline
end
    
exit

